#include "descriptor/descriptor.h"

#define STANZA_X  30
#define STANZA_Y  23
#define STANZA_Z  25

#define NATTR  21
#define BIANCO 0
#define NERO   1
#define ROSSO  2
#define VERDE  3
#define BLU    4
#define MARRONE 5
#define GIALLO 6
#define VETRO 7
#define MARRONEC 8
#define MARRONEB 9
#define GIALLOSC 10
#define ROSSOSC 11
#define ROSSOSC2 12
#define PANNA 13
#define GRIGIO 14
#define SPECCHIO 15

#define MARRONEP 16
#define AZZURRO 17
#define ARANCIO 18
#define ROSA  19
#define NEROR 20

#define FRAMEP1 60
#define FRAMEP2 30
#define FRAMEP3 70
#define FRAMEP4 60
#define FRAMEP5 39
#define FRAMEP55 10
#define FRAMEP6 30
#define FRAMEP7 30
#define FRAMEP8 60
#define FRAMEP9 40
#define FRAMEP10 83
#define FRAMEP11 60
#define FRAMEP12 20
#define FRAMEP13 90
#define FRAMEP14 50

#define FRAME 732

ITEM attr[NATTR];
ITEM lM, lS, lL;

void creaAttributi(){

  attr[BIANCO] = create_attribute("bianco");
  set_color(attr[BIANCO], 1, 1, 1, 0.5, 0.5);

  attr[NERO] = create_attribute("nero");
  set_color(attr[NERO], 0, 0, 0, 0.5, 0.5);

  attr[ROSSO] = create_attribute("rosso");
  set_color(attr[ROSSO], 1, 0, 0, 0.5, 0.5);

  attr[VERDE] = create_attribute("verde");
  set_color(attr[VERDE], 0, 1, 0, 0.5, 0.5);

  attr[BLU] = create_attribute("blu");
  set_color(attr[BLU], 0, 0, 1, 0.5, 0.5);

  attr[MARRONE] = create_attribute("marrone");
  set_color(attr[MARRONE], 0.325, 0.203, 0, 0.5, 0.5);

  attr[MARRONEC] = create_attribute("marronec");
  set_color(attr[MARRONEC], 0.81, 0.59, 0.38, 0.6, 0.5);

  attr[MARRONEB] = create_attribute("marroneb");
  set_color(attr[MARRONEB], 0.56, 0.36, 0.23, 0.5, 0.5);

  attr[GIALLO] = create_attribute("GIALLO");
  set_color(attr[GIALLO], 1, 1, 0, 0.5, 0.5);

  attr[GIALLOSC] = create_attribute("gialloSC");
  set_color(attr[GIALLOSC], 0.88, 0.73, 0.11, 0.9, 0.5);

  attr[ROSSOSC] = create_attribute("rossoSC");
  set_color(attr[ROSSOSC], 0.68, 0.30, 0.22, 0.9, 0.5);
  
  attr[ROSSOSC2] = create_attribute("rossoSC2");
  set_color(attr[ROSSOSC2], 0.50, 0.08, 0, 0.9, 0.5);
 
  attr[PANNA] = create_attribute("panna");
  set_color(attr[PANNA], 0.86, 0.84, 0.74, 0.9, 0.5);

  attr[GRIGIO] = create_attribute("grigio");
  set_color(attr[GRIGIO], 0.46, 0.41, 0.34, 0.9, 0.5);
  set_reflectivity(attr[GRIGIO], 0.001, 0.1);

  attr[VETRO] = create_attribute("VETRO");
  set_color(attr[VETRO], 1, 1, 1, 0.5, 0.5);
  set_reflectivity(attr[VETRO], 0.240, 250);
  set_transparency(attr[VETRO], 1, 0, 5, 1.502);

  attr[SPECCHIO] = create_attribute("SPECCHIO");
  set_color(attr[SPECCHIO], 1, 1, 1, 0.23, 0.0);
  set_reflectivity(attr[SPECCHIO], 0.940, 300);

  attr[MARRONEP] = create_attribute("marrone_chiaro");
  set_color(attr[MARRONEP], 0.506, 0.26, 0.094, 1.0, 0.5);

  attr[AZZURRO] = create_attribute("azzurro");
  set_color(attr[AZZURRO], 0, 0.537, 1, 0.67, 0.5);

  attr[ARANCIO] = create_attribute("arancio");
  set_color(attr[ARANCIO], 1, 0.474, 0, 1, 0.5);

  attr[ROSA] = create_attribute("rosa");
  set_color(attr[ROSA], 1, 0.62, 0.902, 0.5, 0.5); 

  attr[NEROR] = create_attribute("nero_rif");
  set_color(attr[NEROR], 0.15, 0.15, 0.15, 0.5, 0.5);
}

ITEM creaFinestra(){
  ITEM finestra;
  ITEM cornice, mbasso, malto,vetri;
  
  cornice = read_obj("finestra_cornice.obj", "cornice");
  mbasso = read_obj("finestra_internobasso.obj", "inbasso");
  malto = read_obj("finestra_internoalto.obj", "inalto");
  vetri = read_obj("finestra_vetri.obj", "vetri");

  
  finestra = create_list(cornice, "finestra");
  finestra = insert_in_list(finestra, mbasso);
  finestra = insert_in_list(finestra, malto);
  finestra = insert_in_list(finestra, vetri);

  set_scale(finestra, 1.07, 1, 1.02);
  set_translate(finestra, 1.7, STANZA_Y-0.7, 9.3);
  set_domain_texture(finestra, attr[BIANCO], "textures/wood3.hr",0,0.9, 0,0.5, 1, 0.5, 0.5); 
  set_attribute(vetri, attr[VETRO]);

  return finestra;
}



ITEM creaArmadio(){
  ITEM arm;
  ITEM top, base, corpo, piedi, cassetto, pomelli, rilievo, antaS, antaD;

  top = read_obj("arm_top.obj", "top");
  base = read_obj("arm_base.obj", "base");
  corpo = read_nurbs("arm_corpo.db");
  piedi = read_obj("arm_piedi.obj", "piedi");
  cassetto = read_obj("arm_cassetto.obj", "cassetto");
  pomelli = read_obj("arm_pomelli.obj", "pomelli");
  rilievo = read_obj("arm_rilievo.obj", "rilievo");
  antaS = read_obj("arm_antaSx.obj", "antaS");
  antaD = read_obj("arm_antaDx.obj", "antaD");

  arm = create_list(corpo, "armadio");
  arm = insert_in_list(arm, base);
  arm = insert_in_list(arm, top);
  arm = insert_in_list(arm, piedi);
  arm = insert_in_list(arm, pomelli);
  arm = insert_in_list(arm, cassetto);
  arm = insert_in_list(arm, rilievo);
  arm = insert_in_list(arm, antaS);
  arm = insert_in_list(arm, antaD);

  set_translate(arm, STANZA_X-22.2, STANZA_Y-4.2, 0);

 
  set_attribute(arm, attr[PANNA]);
  set_domain_texture(pomelli, attr[BIANCO], "textures/brass.hr",0,0.500, 0,0.500, 1, 0.5, 0.5); 
  return arm;
}

ITEM creaPorta(){
  ITEM porta;
  ITEM struttura, sbalzi, pomello, serratura, stipiteA, stipiteB;

  struttura = read_obj("porta_struttura.obj", "struttura");
  sbalzi = read_obj("porta_sbalzi.obj", "sbalzi");
  pomello = read_nurbs("porta_pomello.db");
  serratura = read_nurbs("porta_serratura.db");
  stipiteA = read_obj ("porta_stipite.obj", "stipiteA");
  stipiteB = read_obj ("porta_stipiteInterno.obj", "stipiteB");
  
  porta = create_list(struttura, "porta");
  porta = insert_in_list(porta, sbalzi);
  porta = insert_in_list(porta, pomello);
  porta = insert_in_list(porta, serratura);
  
  set_scale(porta, 0.9, 1, 1);
  set_scale(stipiteA, 0.9, 1, 1);
  set_scale(stipiteB, 0.9, 1, 1);

  set_translate(porta, STANZA_X-8.5, STANZA_Y-0.4, 0); 
  set_translate(stipiteA, STANZA_X-9.1, STANZA_Y-0.4, 0);
  set_translate(stipiteB, STANZA_X-9.1, STANZA_Y-0.4, 0);
  
  porta = insert_in_list(porta, stipiteA);
  porta = insert_in_list(porta, stipiteB);
  set_attribute(porta, attr[BIANCO]);
  set_domain_texture(struttura, attr[BIANCO], "textures/wood3.hr",0,0.9, 0,0.5, 1, 0.5, 0.5); 
  set_domain_texture(sbalzi, attr[BIANCO], "textures/woodl1.hr",0,0.500, 0,0.500, 1, 0.5, 0.5); 
  set_domain_texture(pomello, attr[BIANCO], "textures/brass.hr",0,0.500, 0,0.500, 1, 0.5, 0.5); 
  set_attribute(stipiteB, attr[NERO]);
  set_domain_texture(stipiteA, attr[BIANCO], "textures/wood3.hr",0,0.9, 0,0.5, 1, 0.5, 0.5); 
  return porta;

}


ITEM creaPerline(){
  ITEM perline, perlineXa, perlineXb, perline2, perlineTmp;
  ITEM perlinaA, perlinaB;
  ITEM perlineYa, perlineYb, perline2y, perlinaAy, perlinaBy, perlineTmpy,perlinaYLast;
  

  int i;
  float x, y;

  perlinaA = read_nurbs("perlina.db");
  perlinaB = read_nurbs("perlina.db");
  set_attribute(perlinaA, attr[ROSSO]);
  set_attribute(perlinaB, attr[MARRONE]);

  set_scale(perlinaA, 0.9, 0.25, 1);
  set_scale(perlinaB, 0.1, 0.125, 1);
  set_translate(perlinaB, 0.9, 0, 0);
  perline = create_list(perlinaA, "perlinebase");
  perline = insert_in_list(perline, perlinaB);
  
  perlineXa = create_list(perline, "perlineXa");
  
  perline2 = create_copy(perline, "perlinee");
  x = 1;
  for(i=0; i<29; i++){
    perlineTmp = create_copy(perline2, "perline");
    set_translate(perlineTmp, x, 0, 0);
    x++;
    perlineXa = insert_in_list(perlineXa, perlineTmp);
  }
  
  perlineXb = create_copy(perlineXa, "perlineXb");
  set_z_rotate(perlineXb,180 , 1);
  set_translate(perlineXb, STANZA_X, STANZA_Y, 0);
  

  perlinaAy = read_nurbs("perlina.db");
  perlinaBy = read_nurbs("perlina.db");
  
  set_z_rotate(perlinaAy, 90, 1);
  set_z_rotate(perlinaBy, 90, 1);
  set_scale(perlinaAy, 0.25, 0.9, 1);
  set_scale(perlinaBy, 0.125, 0.1, 1);
  set_translate(perlinaAy, STANZA_X, 0.1, 0);
  set_translate(perlinaBy, STANZA_X, 0, 0);
  
  perline2y = create_list(perlinaAy, "perllinaY");
  perline2y = insert_in_list(perline2y, perlinaBy);

  y=1;

  perlineYa = create_list(perline2y, "perlineYa");
  
  for(i=0; i<22; i++){
    perlineTmpy = create_copy(perline2y, "perline");
    set_translate(perlineTmpy, 0, y, 0);
    y++;
    perlineYa = insert_in_list(perlineYa, perlineTmpy);
  }


  perlineYb = create_copy(perlineYa, "perlineYb");
  set_translate(perlineYb,-STANZA_X,0, 0);
  set_z_rotate(perlineYb,180 , 1);
  set_translate(perlineYb,0,STANZA_Y, 0);


  

  perline = create_list(perlineXb, "perline");
  perline = insert_in_list(perline, perlineXa);
    perline = insert_in_list(perline, perlineYa); 
  perline = insert_in_list(perline, perlineYb);
  
  set_attribute(perline, attr[BIANCO]);
  set_domain_texture(perline, attr[BIANCO], "textures/wood3.hr",0,0.9, 0,0.5, 1, 0.5, 0.5); 
  return perline;

}

ITEM creaBox(){
  ITEM box;
  ITEM centro, centro_top, decorazione, decorazione2, fodera, fodera_top, lato1, lato1_top, lato2, lato2_top, maniglia, maniglia2, serratura;


  centro = read_nurbs("cassa_centro.db");
  centro_top = read_nurbs("cassa_centro_top.db");
  decorazione = read_nurbs("cassa_decorazione.db");
  decorazione2  = read_nurbs("cassa_decorazione2.db");
  fodera = read_nurbs("cassa_fodera.db");
  fodera_top = read_nurbs("cassa_fodera_top.db");
  lato1 = read_nurbs("cassa_lato1.db");
  lato1_top = read_nurbs("cassa_lato1_top.db");
  lato2 = read_nurbs("cassa_lato2.db");
  lato2_top = read_nurbs("cassa_lato2_top.db");
  maniglia = read_nurbs("cassa_maniglia.db");
  maniglia2 = read_nurbs("cassa_maniglia2.db");
  serratura = read_nurbs("cassa_serratura.db");
  
  box = create_list(centro, "box");
  box = insert_in_list(box, centro_top);
  box = insert_in_list(box, decorazione);
  box = insert_in_list(box, decorazione2);
  box = insert_in_list(box, fodera);
  box = insert_in_list(box, fodera_top);
  box = insert_in_list(box, lato1);
  box = insert_in_list(box, lato1_top);
  box = insert_in_list(box, lato2);
  box = insert_in_list(box, lato2_top);
  box = insert_in_list(box, maniglia);
  box = insert_in_list(box, maniglia2);
  box = insert_in_list(box, serratura);

  set_scale(box, 0.0392, 0.0392, 0.0392);
  set_z_rotate(box, -90, 1);
  set_translate(box, 0, STANZA_Y-2 ,0);

  set_domain_texture(lato1, attr[BIANCO], "textures/box.hr",0,0.9, 0,0.5, 1, 0.5, 0.5);  
  set_domain_texture(lato1_top, attr[BIANCO], "textures/box.hr",0,0.9, 0,0.5, 1, 0.5, 0.5);  
  set_domain_texture(lato2, attr[BIANCO], "textures/box.hr",0,0.9, 0,0.5, 1, 0.5, 0.5);  
  set_domain_texture(lato2_top, attr[BIANCO], "textures/box.hr",0,0.9, 0,0.5, 1, 0.5, 0.5);  
  set_domain_texture(centro, attr[BIANCO], "textures/box1.hr",0,1, 0,1, 1, 0.5, 0.5);  
  set_domain_texture(centro_top, attr[BIANCO], "textures/box.hr",0,1, 0,1, 1, 0.5, 0.5);  
  set_attribute(decorazione, attr[ROSSO]);
  set_attribute(decorazione2, attr[ROSSO]);
  set_domain_texture(maniglia, attr[BIANCO], "textures/brass.hr",0,0.500, 0,0.500, 1, 0.5, 0.5); 
  set_domain_texture(maniglia2, attr[BIANCO], "textures/brass.hr",0,0.500, 0,0.500, 1, 0.5, 0.5); 
  set_domain_texture(serratura, attr[BIANCO], "textures/brass.hr",0,0.500, 0,0.500, 1, 0.5, 0.5); 

  set_domain_texture(fodera, attr[BIANCO], "textures/velluto.hr",0,0.5, 0,0.5, 1, 0.5, 0.5);  
  set_domain_texture(fodera_top, attr[BIANCO], "textures/velluto.hr",0,0.5, 0,0.5, 1, 0.5, 0.5);  

  return box;
  
}

ITEM creaSpecchio(){
  ITEM superficie, cornice;
  ITEM specchio;

  cornice = read_obj("specchio_cornice.obj","cornice");
  superficie = read_nurbs("specchio_specchio.db");
  
  specchio = create_list(cornice, "specchio");
  specchio = insert_in_list(specchio, superficie);
  
  set_scale(specchio, 1, 1.1, 1.1);
  set_translate(specchio, 0.01,9,9.5);
  
  set_attribute(superficie, attr[SPECCHIO]);

  set_domain_texture(cornice, attr[BIANCO], "textures/wood3.hr",0,0.9, 0,0.5, 1, 0.5, 0.5);  
  return specchio;
  
}

ITEM creaPoster(){
  ITEM poster;
  poster = read_nurbs("poster.db");
  set_domain_texture(poster, attr[BIANCO], "textures/poster.hr",0,1, 0,1, 0, 0.5, 0.5);  
  set_scale(poster, 1.7,1, 1.7);
  set_translate(poster, 8, 0.0001, 9.5);
  return poster;
}

ITEM creaPoster2(){
  ITEM poster;
  poster = read_nurbs("poster.db");
  set_domain_texture(poster, attr[BIANCO], "textures/poster2.hr",0,1, 0,1, 0, 0.5, 0.5);  
  set_scale(poster, 1.5,1, 1.5);
  set_z_rotate(poster, 90, 1);
  set_translate(poster, STANZA_X-0.1, STANZA_Y-14, 9.5);
  return poster;
}


ITEM creaSedia(){
 ITEM sedia;
 ITEM gambe, schienale;

 gambe= read_obj("sedia_gambe.obj","gambe");
 schienale = read_nurbs("sedia_schienale.db");

 sedia = create_list(gambe, "sedia");
 sedia = insert_in_list(sedia, schienale);

 set_translate(sedia, 5, 9, 0);
 set_attribute(sedia, attr[GRIGIO]);
 set_attribute(schienale, attr[GIALLOSC]);
 return sedia;
}

ITEM creaLampScrivania(){
  ITEM lampada;
  ITEM base, testa, braccio, raccordi;

  base = read_nurbs("lamps_base.db");
  testa = read_nurbs("lamps_cupola.db");
  braccio = read_obj("lamps_braccio.obj", "braccio");
  raccordi = read_obj("lamps_raccordi.obj", "raccordi");
  lampada = create_list(base, "lampadaScrivania");
  lampada = insert_in_list(lampada, testa);
  lampada = insert_in_list(lampada, braccio);
  lampada = insert_in_list(lampada, raccordi);

  set_translate(lampada, 1.4, 4, 7);
  set_attribute(base, attr[ROSSO]);
  set_attribute(testa, attr[ROSSO]);
  set_attribute(braccio, attr[ROSSO]);
  set_attribute(raccordi, attr[BLU]);
  
  return lampada;
}

ITEM creaScrivania(){
  ITEM scrivania;
  ITEM piano, gambe, body, cassetti, manico;

  piano = read_obj("scrivania_piano.obj", "spiano");
  gambe = read_obj("scrivania_gambe.obj", "sgambe");
  body  = read_obj("scrivania_body.obj", "body");
  cassetti = read_obj("scrivania_cassetti.obj", "cassetti");
  manico = read_obj("scrivania_manico.obj", "manico");

  scrivania = create_list(gambe, "scrivania");
  scrivania = insert_in_list(scrivania, piano);
  scrivania = insert_in_list(scrivania, body);
  scrivania = insert_in_list(scrivania, cassetti);
  scrivania = insert_in_list(scrivania, manico);


  set_translate(scrivania, 0.4, 3, 0);
  set_attribute(piano, attr[GIALLOSC]);
  set_attribute(manico, attr[ROSSOSC2]);
  set_attribute(cassetti, attr[ROSSOSC]);
  set_attribute(body, attr[ROSSOSC]);
  set_attribute(gambe, attr[ROSSOSC]);
  
  return scrivania;
}

ITEM creaLetto(){
 ITEM bed;
 ITEM cap1d, cap1s, cap2s, cap2d, latod, latos, cuscino1, cuscino2, gamba1d, gamba1s, gamba2d, gamba2s, traverso1, traverso2, materasso, testata1, testata2;

 cap1d = read_nurbs("letto_cap_1dx.db");
 cap1s = read_nurbs("letto_cap_1sx.db");
 cap2d = read_nurbs("letto_cap_2dx.db");
 cap2s = read_nurbs("letto_cap_2sx.db");
 latod = read_nurbs("letto_lato_dx.db");
 latos = read_nurbs("letto_lato_sx.db");
 cuscino1 = read_nurbs("letto_cuscinoUnico.db");
 gamba1d = read_nurbs("letto_gamba_1dx.db");
 gamba1s = read_nurbs("letto_gamba_1sx.db");
 gamba2d = read_nurbs("letto_gamba_2dx.db");
 gamba2s = read_nurbs("letto_gamba_2sx.db");
 traverso1 = read_nurbs("letto_traverso1.db");
 traverso2 = read_nurbs("letto_traverso2.db");
 materasso = read_nurbs("letto_materasso.db");
 testata1 = read_nurbs("letto_testata1.db");
 testata2 = read_nurbs("letto_testata2.db");

 bed = create_list(cap1d, "letto");
 bed = insert_in_list(bed, cap1s);
 bed = insert_in_list(bed, cap2d);
 bed = insert_in_list(bed, cap2s);
 bed = insert_in_list(bed, latos);
 bed = insert_in_list(bed, latod);

 bed = insert_in_list(bed, gamba1d);
 bed = insert_in_list(bed, gamba1s);
 bed = insert_in_list(bed, gamba2s);
 bed = insert_in_list(bed, gamba2d);
 bed = insert_in_list(bed, traverso1);
 bed = insert_in_list(bed, traverso2);
 bed = insert_in_list(bed, testata1);
 bed = insert_in_list(bed, testata2);

 set_domain_texture(traverso1, attr[BIANCO], "textures/woodB.hr",0,0.9, 0,0.595, 1, 0.5, 0.5);  
 set_domain_texture(traverso2, attr[BIANCO], "textures/woodB.hr",0,0.9, 0,0.595, 1, 0.5, 0.5); 
 
 set_domain_texture(testata2, attr[BIANCO], "textures/woodB.hr",0,0.9, 0,0.595, 1, 0.5, 0.5);  
 set_domain_texture(testata1, attr[BIANCO], "textures/woodB1.hr",0,0.595, 0,0.9, 1, 0.5, 0.5);  

 set_domain_texture(gamba1s, attr[BIANCO], "textures/woodB1.hr",0,0.595, 0,0.9, 1, 0.5, 0.5);  
 set_domain_texture(gamba1d, attr[BIANCO], "textures/woodB.hr",0,0.9, 0,0.595, 1, 0.5, 0.5);  
 set_domain_texture(gamba2s, attr[BIANCO], "textures/woodB.hr",0,0.9, 0,0.595, 1, 0.5, 0.5);  
 set_domain_texture(gamba2d, attr[BIANCO], "textures/woodB1.hr",0,0.595, 0,0.9, 1, 0.5, 0.5);  

 set_domain_texture(latos, attr[BIANCO], "textures/woodB.hr",0,0.9, 0,0.595, 1, 0.5, 0.5); 
 set_domain_texture(latod, attr[BIANCO], "textures/woodB.hr",0,0.9, 0,0.595, 1, 0.5, 0.5); 

 set_domain_texture(cap1s, attr[BIANCO], "textures/woodB.hr",0,0.9, 0,0.595, 1, 0.5, 0.5); 
 set_domain_texture(cap1d, attr[BIANCO], "textures/woodB.hr",0,0.9, 0,0.595, 1, 0.5, 0.5); 
 set_domain_texture(cap2s, attr[BIANCO], "textures/woodB.hr",0,0.9, 0,0.595, 1, 0.5, 0.5); 
 set_domain_texture(cap2d, attr[BIANCO], "textures/woodB.hr",0,0.9, 0,0.595, 1, 0.5, 0.5); 

 bed = insert_in_list(bed, cuscino1);
 bed = insert_in_list(bed, materasso);

 set_z_rotate(bed, -90, 1);
 set_translate(bed, 0, 13, 0);
 set_scale(bed, 0.565, 0.565, 0.465);
 set_translate(bed, STANZA_X-17.25, 0, 0);


 set_attribute(cuscino1, attr[BIANCO]);
 set_projection_texture(cuscino1, attr[BIANCO], "textures/letto.hr",0, 1, 0.5, 0.5);  
 set_domain_texture(materasso, attr[BIANCO], "textures/letto.hr",0,0.430, 0,0.322, 1, 0.5, 0.5);  
 return bed;


}

ITEM creaLampLetto(){
  ITEM cappello, braccio1, braccio2, snodo1, snodo2, base1, base2;
  ITEM lamp;

  cappello = read_nurbs("lampl_testa.db");
  braccio1 = read_nurbs("lampl_braccio1.db");
  braccio2 = read_nurbs("lampl_braccio2.db");
  snodo1 = read_nurbs("lampl_snodo1.db");
  snodo2 = read_nurbs("lampl_snodo2.db");
  base1 = read_nurbs("lampl_base1.db");
  base2 = read_nurbs("lampl_base2.db");
  
  
  lamp = create_list(base1, "lampadaComodino");
  lamp = insert_in_list(lamp, base2);
  lamp = insert_in_list(lamp, braccio1);
  lamp = insert_in_list(lamp, braccio2);
  lamp = insert_in_list(lamp, snodo1);
  lamp = insert_in_list(lamp, snodo2);
  lamp = insert_in_list(lamp, cappello);

  
  set_attribute(snodo1, attr[BIANCO]);
  set_attribute(snodo2, attr[BIANCO]);
  set_domain_texture(base1, attr[BIANCO], "textures/psyco2.hr",0,0.25, 0,0.15, 1, 0.5, 0.5); 
  set_domain_texture(base2, attr[BIANCO], "textures/psyco2.hr",0,0.25, 0,0.15, 1, 0.5, 0.5); 
  set_domain_texture(braccio1, attr[BIANCO], "textures/psyco2.hr",0,0.25, 0,0.15, 1, 0.5, 0.5); 
  set_domain_texture(braccio2, attr[BIANCO], "textures/psyco2.hr",0,0.25, 0,0.15, 1, 0.5, 0.5); 
  set_domain_texture(cappello, attr[BIANCO], "textures/psyco2.hr",0,0.25, 0,0.15, 1, 0.5, 0.5); 
  set_scale(lamp, 0.25, 0.25, 0.25);
  set_translate(lamp, STANZA_X-2.0, 8.7, 4);
  return lamp;
}


ITEM creaCassettiera(){
  ITEM cassetti, cima, corpo, fondo, piedi, pomelli;
  ITEM cass;
  
  cassetti = read_obj("cass_cassetti.obj", "cassetti");
  cima = read_obj("cass_base.obj", "piano");
  fondo = read_obj("cass_testa.obj", "testa");

  
  corpo = read_nurbs("cass_corpo.db");
  piedi = read_obj("cass_piedi.obj", "piedi");
  pomelli = read_obj("cass_pomelli.obj", "pomelli");
  
  cass = create_list(cassetti, "cassettiera");
  cass = insert_in_list(cass, cima);
  cass = insert_in_list(cass, corpo);
  cass = insert_in_list(cass, fondo);
  cass = insert_in_list(cass, piedi);
  cass = insert_in_list(cass, pomelli);

  set_translate(cass, STANZA_X-3.2, 10.7 ,0);
  set_attribute(cass, attr[PANNA]);

  set_domain_texture(pomelli, attr[BIANCO], "textures/brass.hr",0,0.500, 0,0.500, 1, 0.5, 0.5); 

  return cass;
}



ITEM creaComodino(){
  ITEM cass1, cass2, gamba1, gamba2, gamba3, gamba4, maniglia, piano;
  ITEM como;
  
  cass1 = read_nurbs("como_cass1.db");

  cass2 = read_nurbs("como_cass2.db");
  gamba1 = read_nurbs("como_gamba1.db");
  gamba2 = read_nurbs("como_gamba2.db");
  gamba3 = read_nurbs("como_gamba3.db");
  gamba4 = read_nurbs("como_gamba4.db");
  maniglia = read_nurbs("como_maniglia.db");
  piano = read_nurbs("como_piano.db");

  como = create_list(cass1, "comodino");
  como = insert_in_list(como, cass2);
  como = insert_in_list(como, gamba1);
  como = insert_in_list(como, gamba2);
  como = insert_in_list(como, gamba3);
  como = insert_in_list(como, gamba4);
  como = insert_in_list(como, maniglia);
  como = insert_in_list(como, piano);


 set_scale(como, 1.2, 1, 0.8);
 set_translate(como, STANZA_X-2.6, 7.8 ,0);


  set_attribute(como, attr[MARRONEC]);
  set_domain_texture(maniglia, attr[BIANCO], "textures/brass.hr",0,0.500, 0,0.500, 1, 0.5, 0.5); 
  return como;



}


ITEM creaStanza(){
  ITEM pavimento, soffitto, pareteA, pareteB, pareteC, pareteD, stanza;
  ITEM piano;

  piano = read_nurbs("piano.db");
  
  pavimento = create_copy(piano, "pavimento");
  set_scale(pavimento, STANZA_X, STANZA_Y, 1);


  soffitto = create_copy(piano, "soffitto");
  set_scale(soffitto, STANZA_X, STANZA_Y, 1);
  set_translate(soffitto, 0, 0, STANZA_Z);

  pareteA = create_copy(piano, "pareteA");
  set_y_rotate(pareteA, 90, 1);
  set_scale(pareteA, 1, STANZA_Y, STANZA_Z);  
  set_translate(pareteA, 0, 0, STANZA_Z);


  pareteB = create_copy(piano, "pareteB");
  set_x_rotate(pareteB, 90, 1);
  set_scale(pareteB, STANZA_X, 1, STANZA_Z);

  pareteC = create_copy(piano, "pareteC");
  set_y_rotate(pareteC, 90, 1);
  set_scale(pareteC, 1, STANZA_Y, STANZA_Z);  
  set_translate(pareteC, STANZA_X, 0, STANZA_Z);

  pareteD = read_nurbs("parete.dbe");
  set_translate(pareteD, 0, STANZA_Y, 0);

  stanza = create_list(pavimento, "stanza");
  stanza = insert_in_list(stanza, soffitto); 
  stanza = insert_in_list(stanza, pareteA);     
  stanza = insert_in_list(stanza, pareteB);  
  stanza = insert_in_list(stanza, pareteC);  
  stanza = insert_in_list(stanza, pareteD);  
  
  set_attribute(stanza, attr[BIANCO]);
  set_domain_texture(pareteA, attr[BIANCO], "textures/nuvoleA.hr",0,0.200, 0,0.150, 1, 0.5, 0.5); 
  set_domain_texture(pareteB, attr[BIANCO], "textures/nuvoleB.hr",0,0.150, 0,0.200, 1, 0.5, 0.5); 
  set_domain_texture(pareteC, attr[BIANCO], "textures/nuvoleA.hr",0,0.200, 0,0.150, 1, 0.5, 0.5); 
  set_domain_texture(pareteD, attr[BIANCO], "textures/nuvoleD.hr",0,0.150, 0,0.200, 1, 0.5, 0.5); 
  set_domain_texture(pavimento, attr[BIANCO], "textures/parquet3.hr",0,0.900, 0,0.900, 1, 0.5, 0.5); 

  return stanza;

}


ITEM creaMrpotato(){
  ITEM corpo, scarpe, occhioSx, occhioDx,cappello,naso;
  ITEM cigliaSx, cigliaDx;
  ITEM pupillaSx,pupillaDx;
  ITEM orecchioS;
  ITEM orecchioD;
  ITEM braccia;
  ITEM labbroU, labbroD;
  ITEM mrpotato;
  

  scarpe = read_obj("mrpotato_scarpeG.obj", "scarpe");
  corpo= read_nurbs("mpotato_corpo.db");
  occhioSx = read_nurbs("mpotato_occhiodxP2f.dbe");
  pupillaSx = read_nurbs("pupillaSx1.dbe");
  pupillaDx = read_nurbs("pupillaDx1.db");

  occhioDx = read_nurbs("mpotato_occhiosxP2f.dbe");
  cappello = read_nurbs("mrpotato_cappelloLast.db");
  naso = read_nurbs("MrPotato_naso.db");

  cigliaSx = read_nurbs("MrPotato_sopracciglio_sx.db");
  cigliaDx = read_nurbs("MrPotato_sopracciglio_dx.db");
  braccia = read_obj("MrPotato_Braccia.obj", "braccia");
  labbroU = read_nurbs("MrPotato_labbro_sup.db");
  labbroD = read_nurbs("MrPotato_labbro_inf.db");


  orecchioS = read_nurbs("MrPotato_orecchio_sx.db"); 
 
  orecchioD = read_nurbs("MrPotato_orecchio_dx.db"); 
  
  mrpotato = create_list(corpo, "mrpotato");
  mrpotato = insert_in_list(mrpotato, scarpe);
  mrpotato = insert_in_list(mrpotato, occhioSx);
  mrpotato = insert_in_list(mrpotato, pupillaSx);
  mrpotato = insert_in_list(mrpotato, pupillaDx);
  mrpotato = insert_in_list(mrpotato, occhioDx);
  mrpotato = insert_in_list(mrpotato, cappello);
  mrpotato = insert_in_list(mrpotato, naso);
  mrpotato = insert_in_list(mrpotato, cigliaDx);
  mrpotato = insert_in_list(mrpotato, cigliaSx);
  mrpotato = insert_in_list(mrpotato, braccia);
  mrpotato = insert_in_list(mrpotato, labbroU);
  mrpotato = insert_in_list(mrpotato, labbroD);
      
  mrpotato = insert_in_list(mrpotato, orecchioS);     
  mrpotato = insert_in_list(mrpotato, orecchioD); 

 
  
  
  set_attribute(scarpe, attr[AZZURRO]);
  set_attribute(labbroU, attr[ROSSO]);
  set_attribute(labbroD, attr[ROSSO]);


  set_attribute(cappello, attr[NEROR]);


  set_attribute(cigliaSx, attr[NEROR]);
  set_attribute(pupillaSx, attr[NERO]);
  set_attribute(pupillaDx, attr[NERO]);
  set_attribute(cigliaDx, attr[NEROR]);

  set_attribute(braccia, attr[BIANCO]);
  set_attribute(occhioDx, attr[BIANCO]);
  set_attribute(occhioSx, attr[BIANCO]);
  set_attribute(naso, attr[ARANCIO]);
  set_attribute(orecchioS, attr[ROSA]); 

  set_attribute(orecchioD, attr[ROSA]); 

  set_bump_texture(corpo, attr[MARRONEP], "textures/patata2.hr", 0, 0.1559, 0, 0.1037, 1, 0.1, 1);

  set_z_rotate(mrpotato, 180, 1);
  set_scale(mrpotato,0.3, 0.3, 0.3);

  set_translate(mrpotato, 3.4, 11, 7.3);
  return mrpotato;
}


void creaLuci(){
  set_ambient_light(1,1,1,0.5);
  lM = create_point_light(STANZA_X/2,STANZA_Y/2, STANZA_Z-4, 1,1,1, 0.01,100, "mainTestLight");  
  lS = create_point_light(5, 6.8, 10.5, 1,1,1, 0.01,100, "lampadaTavolo");  
  lL = create_point_light(STANZA_X-2.0 , 7.5, 6.4, 1,1,1, 1,100, "lampadaLetto");  

}

int main(void){
  ITEM allObject, stanza;
  float intS, intL, intM;
  float incrS, decrL, incrM;
  int bS, bM, bL, bP;
  int i=0;

  bS=0;
  bM=0;
  bL=0;

  intS=0.01;
  intL=1;
  intM=0.01;


  creaAttributi(attr);
  creaLuci();
  stanza = creaStanza();
  
  allObject = create_list(stanza, "all");

  allObject = insert_in_list(allObject, creaBox());
  allObject = insert_in_list(allObject, creaPerline());
  allObject = insert_in_list(allObject, creaPorta());
   allObject = insert_in_list(allObject, creaArmadio());  
  allObject = insert_in_list(allObject, creaFinestra());
  allObject = insert_in_list(allObject, creaLetto()); 
  allObject = insert_in_list(allObject, creaComodino());
  allObject = insert_in_list(allObject, creaCassettiera());  
  allObject = insert_in_list(allObject, creaLampLetto());
  allObject = insert_in_list(allObject, creaScrivania());
  allObject = insert_in_list(allObject, creaSedia());
  allObject = insert_in_list(allObject, creaLampScrivania());
  allObject = insert_in_list(allObject, creaSpecchio());
  allObject = insert_in_list(allObject, creaPoster());
  allObject = insert_in_list(allObject, creaPoster2());

  incrS = 0.9/(FRAMEP3-30);
  decrL = 0.999/FRAMEP4;
  incrM = 0.9/FRAMEP8;
  
  bS = FRAMEP1+FRAMEP2;
  bL = bS+FRAMEP3;
  bM = bL+FRAMEP4+FRAMEP5+FRAMEP55+FRAMEP6+FRAMEP7;
  bP = bM+FRAMEP8+FRAMEP9+FRAMEP10+FRAMEP11+FRAMEP12;


  for(i=0; i<FRAME; i++){
    if(i>bS && i<=bS+(FRAMEP3-30)){ // incremento la luce della lampada sul tavolo
      intS+=incrS;
      set_point_light(5, 6.8, 10.5, 1,1,1,intS,100, lS);  
    }

    if(i>bL && i<=bL+FRAMEP4){ // spengo la lampada sul comodino
      intL-=decrL;
      set_point_light(STANZA_X-2.0 , 7.5, 6.4, 1,1,1,intL,100, lL);  
    }

    if(i>bM&& i<=bM+FRAMEP8){ // incremento la luce della camera
      intM+=incrM;
      set_point_light(STANZA_X/2,STANZA_Y/2, STANZA_Z-4, 1,1,1,intM,100, lM);  
    }
    
    if(i==bP){
      allObject = insert_in_list(allObject,creaMrpotato());
      set_point_light(5, 6.8, 10.5, 1,1,1,0.5,100, lS);  
      set_point_light(STANZA_X/2,STANZA_Y/2, STANZA_Z-4, 1,1,1,1,100, lM);  
    }
    
    save_scene_ani(FRAME, "all.ani", "all", "Project", allObject);
  }
  
  return(0);
}
